﻿using HarmonyLib;
using System.Reflection;
using UnityEngine;

public class GlassHoneyUse : Mod
{
    private const string logPrefix = "[<color=#0000ff>BetterJars</color>] ";
    private const string HARMONY_ID = "com.nundir.betterjars";
    private Harmony harmonyInstance;

    public void Start()
    {
        ComponentManager<GlassHoneyUse>.Value = this;

        harmonyInstance = new Harmony(HARMONY_ID);
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());

        Debug.Log(logPrefix + " loaded!");
    }

    public void OnModUnload()
    {
        Debug.Log(logPrefix + " unloaded!");
    }

    public void OnModifyTank(Network_Player player, float amount, Item_Base itemType = null)
    {
        if (!itemType || !(itemType.name == "Jar_Honey")) return;

        GiveGlass();
    }

    public void OnConsumeItem(Item_Base item)
    {
        if (!(item.name == "Jar_Honey")) return;

        GiveGlass();
    }

    public void GiveGlass()
    {
        RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Glass").UniqueName, 1);
    }
}

[HarmonyPatch(typeof(Tank)), HarmonyPatch("ModifyTank")]
internal class ModifyTankPatch
{
    private static void Postfix(Tank __instance, Network_Player player, float amount, Item_Base itemType = null)
    {
        if (player == RAPI.GetLocalPlayer())
        {
            ComponentManager<GlassHoneyUse>.Value.OnModifyTank(player, amount, itemType);
        }
    }
}

[HarmonyPatch(typeof(PlayerStats)), HarmonyPatch("Consume")]
internal class ConsumePatch
{
    private static void Postfix(PlayerStats __instance, Item_Base edibleItem)
    {
        if (__instance.GetComponent(typeof(Network_Player)) == RAPI.GetLocalPlayer())
        {
            ComponentManager<GlassHoneyUse>.Value.OnConsumeItem(edibleItem);
        }
    }
}